/**
*
*/

import RTIcap.*;
import java.util.*;

/**
*/
public class AttributeNaming  implements RTIDebug
{
   ObjectRecord father;
   Hashtable idToName = new Hashtable();
   Hashtable nameToId = new Hashtable();

   /**
   */ 
   public
   AttributeNaming(ObjectRecord _boss) 
   { father = _boss; }

   /**
   */
   public
   String getAttributeName(short theHandle)
           throws RTIcap.AttributeNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
   {
       String ret = (String) idToName.get( new Short(theHandle)); 

       if(ret==null) throw new RTIcap.AttributeNotDefined();

       return ret;

   }// end of getAttributeName()

   /**
   */
   public
   short getAttributeHandle(String theName)
         throws RTIcap.NameNotFound, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError,
                RTIcap.Deadlock
   {
       Short ret= (Short) nameToId.get(theName);

       if(ret==null) throw new RTIcap.NameNotFound();

       return ret.shortValue();

   }// end of getAttributeHandle()

   /**
   */
   public
   short addAttribute(String theName)
   {
       if(DEBUG) System.out.println(" in addAttribute() of AttributeNaming ");

       short cnt = (short) (nameToId.size()+1);
       
       idToName.put(new Short(cnt),theName);
       nameToId.put(theName, new Short(cnt)); 

       if(DEBUG) System.out.println(" cnt "+cnt);

       return cnt;

   }// end of addAttribute()

   public int getNumberOfAttributes() { return nameToId.size(); }


}// end of class AttributeNaming

